/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2024, Arnaud Roques
 *
 * Project Info:  https://plantuml.com
 * 
 * If you like this project or if you find it useful, you can support us at:
 * 
 * https://plantuml.com/patreon (only 1$ per month!)
 * https://plantuml.com/paypal
 * 
 * This file is part of PlantUML.
 *
 * PlantUML is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * PlantUML distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 *
 * Original Author:  Arnaud Roques
 */

package smetana.core.debug;

public final class SmetanaDebugSlow {

	// ::remove file when __CORE__

	// ::comment when __CORE__
	public static boolean TRACE = false;
	public static boolean TRACE_FINAL_CALL = false;
	public static boolean VERY_VERBOSE = false;

	private static Purify purify;

	private static Purify purify() {
		if (purify == null)
			purify = new Purify();
		return purify;
	}
	// ::done

	static public void LOG(String s) {
		// ::comment when __CORE__
		if (TRACE)
			purify().logline(s);
		// ::done

	}

	static public void ENTERING(String signature, String methodName) {
		// ::comment when __CORE__
		if (TRACE)
			purify().entering(signature, methodName);
		// ::done
	}

	static public void LEAVING(String signature, String methodName) {
		// ::comment when __CORE__
		if (TRACE)
			purify().leaving(signature, methodName);
		// ::done
	}

	public static void reset() {
		// ::comment when __CORE__
		if (TRACE)
			purify().reset();
		// ::done
	}

	public static void printMe() {
		// ::comment when __CORE__
		if (TRACE && TRACE_FINAL_CALL)
			purify().printMe();
		// ::done
	}

}
